DFS HDU 2614

很水的。但是wa了很多遍,因为写num【1】【1】。。。

改成0之后就过了。。。虽然不知道为什么。。。

Beat

Time Limit: 6000/2000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)

Total Submission(s): 659    Accepted Submission(s): 415

Problem Description

Zty is a man that always full of enthusiasm. He wants to solve every kind of difficulty ACM problem in the world. And he has a habit that he does not like to solve

a problem that is easy than problem he had solved. Now yifenfei give him n difficulty problems, and tell him their relative time to solve it after solving the other one.

You should help zty to find a order of solving problems to solve more difficulty problem.

You may sure zty first solve the problem 0 by costing 0 minute. Zty always choose cost more or equal time’s problem to solve.

Input

The input contains multiple test cases.

Each test case include, first one integer n ( 2< n < 15).express the number of problem.

Than n lines, each line include n integer Tij ( 0<=Tij<10), the i’s row and j’s col integer Tij express after solving the problem i, will cost Tij minute to solve the problem j.

Output

For each test case output the maximum number of problem zty can solved.

Sample Input

3
0 0 0
1 0 1
1 0 0
3
0 2 2
1 0 1
1 1 0
5
0 1 2 3 1
0 0 2 3 1
0 0 0 3 1
0 0 0 0 2
0 0 0 0 0

Sample Output

3
2
4

Hint

Hint: sample one, as we know zty always solve problem 0 by costing 0 minute.
So after solving problem 0, he can choose problem 1 and problem 2, because T01 >=0 and T02>=0.
But if zty chooses to solve problem 1, he can not solve problem 2, because T12 < T01.
So zty can choose solve the problem 2 second, than solve the problem 1.  
#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>
#include <limits.h>
#include <ctype.h>
#include <string.h>
#include <string>
#include <math.h>
#include <algorithm>
#include <iostream>
#include <queue>
#include <stack>
#include <deque>
#include <vector>
#include <set>
#include <map>
using namespace std;
#define MAXN 20

int num[MAXN][MAXN];
int vis[200];
int n;
int ans;

int Max(int a,int b){
    return a>b?a:b;
}

void DFS(int h,int count,int t){
    int i;
    ans = Max(ans,t);
    for(i=1;i<=n;i++){
        /*if(vis[i] == 1){
            continue;
        }
        if(num[h][i] < count){
            continue;
        }*/
        if(vis[i]==0 && num[h][i]>=count){
            vis[i] = 1;
            DFS(i,num[h][i],t+1);
            vis[i] = 0;
        }
        /*vis[i] = 1;
        DFS(i,num[h][i],t+1);
        vis[i] = 0;*/
   }
}

int main(){
    int i,j;

    while(~scanf("%d",&n)){
        memset(vis,0,sizeof(vis));
        /*for(i=0;i<MAXN;i++){
            for(j=0;j<MAXN;j++){
                num[i][j] = 0;
            }
        }*/
        for(i=1;i<=n;i++){
            for(j=1;j<=n;j++){
                scanf("%d",&num[i][j]);
            }
        }
        vis[1] = 1;
        ans = 0;
        //printf("%d\n",num[1][1]);
        DFS(1,0,1);
        printf("%d\n",ans);
    }

    return 0;
}
时间: 2024-12-21 16:34:17

DFS HDU 2614的相关文章

D - DFS HDU - 2660

D - DFS HDU - 2660 I have N precious stones, and plan to use K of them to make a necklace for my mother, but she won't accept a necklace which is too heavy. Given the value and the weight of each precious stone, please help me find out the most valua

HDU 2614 Beat(DFS)

题目链接 Problem Description Zty is a man that always full of enthusiasm. He wants to solve every kind of difficulty ACM problem in the world. And he has a habit that he does not like to solvea problem that is easy than problem he had solved. Now yifenfe

HDU 2614 Beat 深搜DFS

这道题目还是比较水的,但是题意理解确实费了半天劲,没办法 谁让自己是英渣呢! 题目大意: 猪脚要解决问题, 他有个习惯,每次只解决比之前解决过的问题的难度要大. 他给我们一个矩阵  矩阵的 i 行 j 列表示 解决完第 i 个问题后再解决第 j 个问题 花费时间为 T[i][j] 也就是 题目的难度. 并且他是从第0个问题开始解决的,第0个问题花费的时间为 0 下面是代码 : 1 #include<stdio.h> 2 #include<stdlib.h> 3 #include&l

I - Beat HDU - 2614 DFS

Beat Time Limit: 6000/2000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)Total Submission(s): 2184    Accepted Submission(s): 1256 Problem Description Zty is a man that always full of enthusiasm. He wants to solve every kind of difficu

变形课(DFS hdu 1181)

变形课 Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 131072/65536 K (Java/Others)Total Submission(s): 19133    Accepted Submission(s): 6892 Problem Description 呃......变形课上Harry碰到了一点小麻烦,因为他并不像Hermione那样能够记住所有的咒语而随意的将一个棒球变成刺猬什么的,但是他发现了变形咒语的一个统一规

(水DFS) hdu 5024

D - Wang Xifeng's Little Plot Time Limit:1000MS     Memory Limit:65536KB     64bit IO Format:%I64d & %I64u Submit Status Practice HDU 5024 Appoint description:  System Crawler  (2015-04-14) Description <Dream of the Red Chamber>(also <The Sto

DFS HDU 1342

很水的DFS Lotto Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others) Total Submission(s): 1515    Accepted Submission(s): 752 Problem Description In a Lotto I have ever played, one has to select 6 numbers from the set {1,2

(dfs) hdu 2258

Continuous Same Game (1) Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)Total Submission(s): 465    Accepted Submission(s): 176 Problem Description Continuous Same Game is a simple game played on a grid of colored

DFS/hdu 1010 Tempter of the Bone

题意 给出一个n*m的地图,s:起点,d:终点,x:障碍物,.:可以走的格子 给出一个时间t,求问是否可以恰好用t时间从起点走到终点.走一步为一个时间. 注意:走过的格子不能再走 注意2:是在时间t刚好到达,而不是时间t以内!也就是说可以在地图上绕远,反正就要在时间t到达! 分析 很普通的深搜,但是有2点剪枝: 1.在刚读入数据后剪枝:当可以走的格子本来就比时间t还短时,必然无法在t时间走到终点 1 if (m*n-xx<=t) //xx is the number of 'X' 2 { 3 p